// Optimal Binary Search Tree
#include <cstdio>

FILE * fin = fopen("arb.in", "r");
FILE * fout = fopen("arb.out", "w");

int i, j, k, N;
int cost[101][101], best[101][101];
int f[101];
#define INF 999999

void DetTree() // O(n^3)
{
    int  t;
    for (i = 1; i <= N; ++i )
     	for ( j = i + 1; j <= N + 1; ++j )
            cost[i][j] = INF;
    // costul crearii unui arbore cu noduri din intervalul[i, j]  }

     for ( i = 1; i <= N; ++i )
     	cost[i][i] = f[i];  // arbori cu un singur nod


    for ( j = 1; j < N; ++j )     //  j = largimea intervalului [i, ..., i + j] - dinamica mixta
        for ( i = 1; i <= N - j; ++i )
        {
            for ( k = i; k <= i + j; ++k ) //  fixeaza rad in k }
            {

                t = cost[i][k - 1] + cost[k + 1][i + j]; //  uneste subarborii cu noduri[i..k-1] }
                if ( t < cost [i][i + j] )
                {
                    cost[i][i + j] = t;
                    best[i][i + j] = k;
                }
            }

            t = 0;
            for (k = i; k <=  i + j; ++k )
                t += f[k];        // mai bine cu suma partiale s[k] = f[1]+...+f[k] }

            cost[i][i + j] += t;   // aduna suma frecv tuturor nodurilor }
	}         /* din moment ce fiecare nod e cu un pas mai departe de rad }
                   in noul arbore; dist pana la i a crecut cu 1 si ponderea
                     cu 1*f[i] */
}


void Write()
{
     fprintf(fout, "%d\n", cost[1][N]);
     for ( i = 1; i <= N; ++i )
     {
          for (j = i; j <= N; ++j )
              fprintf(fout, "%d %d %d\n", i, j, best[i][j]);
          fprintf(fout, "\n");
     }
     fclose(fout);
}

void ReadArb()
{
    fscanf(fin, "%d", &N);

    for ( i = 1; i <= N; ++i )
         fscanf(fin,"%d", &f[i]);
     fclose(fin);
}

int main()
{
     ReadArb();
     DetTree();
     Write();
}

