// Optimal Binary Search Tree

#include <cstdio>
#include <stdlib.h>

FILE * fin = fopen("arb.in", "r");
FILE * fout = fopen("arb.out", "w");


typedef struct NodeT {
    char key;
    struct NodeT* left, *right;

} NodeT;



int i, j, k, N;
int cost[101][101], best[101][101];
char key[101];
int f[101];
#define INF 999999

void DetTree()
{
    int  t;
    for (i = 1; i <= N; ++i )
     	for ( j = i + 1; j <= N + 1; ++j )
            cost[i][j] = INF;
    // costul crearii unui arbore cu noduri din intervalul[key[i], ..., key[j]]

     for ( i = 1; i <= N; ++i )
     	cost[i][i] = f[i];  // arbori cu un singur nod


    for ( j = 1; j < N; ++j )     //  j = largimea intervalului [i, ..., i + j] - dinamica mixta
        for ( i = 1; i <= N - j; ++i )
        {
            for ( k = i; k <= i + j; ++k ) //  fixeaza rad in k }
            {
                t = cost[i][k - 1] + cost[k + 1][i + j]; //  uneste subarborii cu noduri[i..k-1] }
                if ( t < cost [i][i + j] )
                {
                    cost[i][i + j] = t;
                    best[i][i + j] = k;
                }
            }

            t = 0;
            for (k = i; k <=  i + j; ++k )
                t += f[k];        // mai bine cu suma partiale s[k] = f[1]+...+f[k] }

            cost[i][i + j] += t;   // aduna suma frecv tuturor nodurilor }
	}         /* din moment ce fiecare nod e cu un pas mai departe de rad }
                   in noul arbore; dist pana la i a crecut cu 1 si ponderea
                     cu 1*f[i] */
}


void Write()
{
     fprintf(fout, "%d\n", cost[1][N]);
   //  fprintf(fout, "%d\n", key[best[1][N]]);

}

void ReadArb()
{
    fscanf(fin, "%d ", &N);
    for ( i = 1; i <= N; ++i )
         fscanf(fin,"%d", &f[i]);
    fgetc(fin);
    for ( i = 1; i <= N; ++i )
         fscanf(fin,"%c ", &key[i]);

     fclose(fin);
}

NodeT* BuildTree(int i, int j)
{

    NodeT* p;
    if ( i >= j ) return p = NULL;
    p = (NodeT*) malloc(sizeof(NodeT));
    p->key = key[best[i][j]];
    printf("%d %d %d %c", i, j, best[i][j], p->key ); getchar();
    p->left = BuildTree(i, best[i][j] - 1);
    p->right = BuildTree(best[i][j] + 1, j);
    return p;
}

void InOrder(NodeT* root)
{
    if ( root == NULL ) return;
    InOrder(root->left);
    fprintf(fout, "%c ", root->key);
    InOrder(root->right);
}

int main()
{
    ReadArb();
    DetTree();
    NodeT * root = BuildTree(1, N);
    Write();
    InOrder(root);
    fclose(fout);

}

