#include <stdio.h>
#include <stdlib.h>


typedef struct node {
    int key;
    node *ls, *rs; // pointers to left son and right son
} Node;

Node* root;


void Read();
void Insert(Node* p, int v);
void Order(Node* p);
void PreOrder(Node* p);
void PostOrder(Node* p);
Node* FindSmallest(Node* p);
Node* Find(Node* p, int v);   // search the value v into the tree

int main()
{
    freopen("tree.in", "r", stdin);
    freopen("tree.out", "w", stdout);
       // printf("%d ", v);
    Read();

    printf("Order: ");
    Order(root);
    printf("\nPreOrder: ");
    PreOrder(root);
    printf("\nPostOrder: ");
    PostOrder(root);
    Node* p = FindSmallest(root);
    if ( p != NULL )
        printf("\nThe smallest node is %d\n", p->key);
    else
        printf("\nThe tree is empty! \n");

    int v = 20;
    p = Find(root, v);
    if ( p != NULL )
        printf("\nThe value %d exist in the tree\n", p->key);
    else
        printf("\nThe value %d doesn't exist in the tree\n", v);
    fclose(stdin); fclose(stdout);
}


void Read()
{
    int v;
    scanf("%d", &v);    // first vertice will be the root
    root = (Node*) malloc(sizeof(Node));
    root->key = v;
    root->ls = root->rs = NULL;
    while ( scanf("%d", &v ) == 1)
        Insert(root, v);
}

void PreOrder(Node* p)
{
    if ( p == NULL ) return;
    printf("%d ", p->key);
    PreOrder(p->ls);
    PreOrder(p->rs);
}
void PostOrder(Node* p)
{
    if ( p == NULL ) return;
    PostOrder(p->ls);
    PostOrder(p->rs);
    printf("%d ", p->key);
}

void Order(Node* p)
{
    if ( p == NULL ) return;
    if ( p->ls) Order(p->ls);
    printf("%d ", p->key);
    if ( p->rs) Order(p->rs);
}

void Insert(Node* p, int v)
{
    if ( v >= p->key )
    {
        if ( p->rs ) // if left son does exist
            Insert(p->rs, v);
        else // insert a new node
        {
            Node* q = (Node*)malloc(sizeof(Node));
            q->ls = q->rs = NULL;
            q->key = v;
            p->rs = q;
        }
    }

    if ( v < p->key )
    {
        if ( p->ls ) // if left son does exist
            Insert(p->ls, v);
        else // insert a new node
        {
            Node* q = (Node*)malloc(sizeof(Node));
            q->ls = q->rs = NULL;
            q->key = v;
            p->ls = q;
        }
    }
}

Node* FindSmallest(Node* p) // Find the smallest node in BST
{
    if ( p == NULL ) return NULL;
    if ( p->ls == NULL )
        return p;
    return FindSmallest(p->ls);
}

Node* Find(Node* p, int v)
{
    if ( p == NULL ) return NULL;
    if ( v == p->key ) return p;
    if ( v > p->key )
        return Find(p->rs, v);
    return Find(p->ls, v);

}
